package de.dfki.km.academicresearch.eswc2016challenge.cameraready;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class EdgeDelta implements Comparable<EdgeDelta> {

    int edge;
    
    byte delta;

    //go to parent is a crossedge
    boolean crossedgeToParent;
    EdgeDelta parent;
    int parentEdgeId;
    
    List<EdgeDelta> children = new ArrayList<>(4);

    //32 + 8 + 8 + 32 = 80 bits
    
    public EdgeDelta(int edge, byte delta) {
        this.edge = edge;
        this.delta = delta;
        this.crossedgeToParent = false;
    }

    public EdgeDelta(int edge, byte delta, boolean crossedgeToParent) {
        this.edge = edge;
        this.delta = delta;
        this.crossedgeToParent = crossedgeToParent;
    }

    public EdgeDelta(EdgeDelta other) {
        this.edge = other.edge;
        this.delta = other.delta;
        this.crossedgeToParent = other.crossedgeToParent;
        this.parent = other.parent;
    }

    @Override
    public int compareTo(EdgeDelta other) {
        return Double.compare(this.delta, other.delta);
    }

    @Override
    public String toString() {
        return String.valueOf(edge);
    }

}
