package de.dfki.km.academicresearch.eswc2016challenge.cameraready;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

public class GenerateFilteredDatasetGZIP {

    public static void createFilteredDatasetTraining() throws FileNotFoundException, IOException {
        createFilteredDataset(new File("training_dataset.nt.gz"), new File("training_dataset_filtered.nt.gz"));
    }

    public static void createFilteredDatasetEval() throws FileNotFoundException, IOException {
        createFilteredDataset(new File("evaluation_dataset.nt.gz"), new File("evaluation_dataset_filtered.nt.gz"));
    }

    private static void createFilteredDataset(File from, File to) throws IOException {
        try (BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new GZIPOutputStream(new FileOutputStream(to))))) {
            try (BufferedReader br = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(from))))) {
                String line;
                while ((line = br.readLine()) != null) {
                    writer.write(line.replace("^^<http://dbpedia.org/datatype/brake horsepower>", "^^<http://dbpedia.org/datatype/brake%20horsepower>") + "\n");
                }
            }
        }
    }

    public static void main(String[] args) {
        try {
            createFilteredDatasetEval();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
