package de.dfki.km.academicresearch.eswc2016challenge.cameraready;

import com.google.common.collect.HashBiMap;
import java.util.ArrayList;
import java.util.List;
import org.apache.jena.rdf.model.ResourceFactory;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class ModifiedEppsteinP {
    /*
    this.invert = invert;
        this.useP = P != null;
        
        if(useP) {
            int dummyId = data.getUri2id().size();
            data.getUri2id().put("http://dummy", dummyId);
            
            
            
            //data = data.extend(invert, 0, 0, 0);
        }
    
    
        pId = useP ? uri2id.get(P) : -1;
    */
    
    private ModifiedEppstein modepp;
    private final String dummy = "http://dummy";
    private int k;
    private boolean noSolution;
    private String source;
    private int sourceId;
    
    public ModifiedEppsteinP(String source, String target, String P, int k, DataBasis data) throws Exception {
        this.source = source;
        
        //copy map
        data = new DataBasis(HashBiMap.create(data.getUri2id()), data.getTriplearray());
        
        this.k = k;
        
        //dummy
        int dummyId = data.getUri2id().size();
        data.getUri2id().put(dummy, dummyId);
        
        //ids
        sourceId = data.getUri2id().get(source);
        int pId = data.getUri2id().get(P);
        
        //src uri over P
        List<Integer> extension = new ArrayList<>();
        int[] t = data.getTriplearray();
        for(int i = 0; i < t.length; i += 3) {
            if(t[i+0] == sourceId && t[i+1] == pId) {
                extension.add(dummyId);
                extension.add(pId);
                extension.add(t[i+2]);
            }
        }
        
        noSolution = extension.isEmpty();
        
        if(!noSolution) {
            //extend
            data = data.extend(false, DataBasis.toPrimitive(extension.toArray(new Integer[0])));
            
            modepp = new ModifiedEppstein(target, data);
        }
    }
    
    public PathList find() throws Exception {
        return noSolution ? new PathList() : modepp.find(dummy, k, sourceId).replaceEveryFirstResourceWith(ResourceFactory.createResource(source));
    }
    
}
