package de.dfki.km.academicresearch.eswc2016challenge.cameraready;

//import de.dfki.km.academicresearch.eswc2016challenge.util.PropertyPath;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import org.apache.jena.graph.Triple;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public abstract class WeightedPathFinder extends URIPathFinder {

    private static final Logger logger = LoggerFactory.getLogger(WeightedPathFinder.class);

    private Map<String, Double> edgeWeights = new HashMap<>();

    @Override
    public void send(Triple item) {
        super.send(item);
        /*
        if (item.getSubject().isURI() && item.getPredicate().isURI() && item.getPredicate().getURI().equals(PropertyPath.weight.getURI()) && item.getObject().isLiteral()) {
            Object o = item.getObject().getLiteralValue();
            Double d = new Double(o.toString());
            edgeWeights.put(item.getSubject().getURI(), d);
            //sendEdgeWeight(item.getSubject().getURI(), d); //dont send it yet, because all edges are not added right now
        }
        */
    }

    @Override
    public void endStreaming() throws Exception {
        super.endStreaming();
        for (Entry<String, Double> e : edgeWeights.entrySet()) {
            sendEdgeWeight(e.getKey(), e.getValue());
        }
    }

    public void sendEdgeWeight(String predicate, double weight) {

    }

}
