package de.dfki.km.academicresearch.eswc2016challenge.unittests;

import de.dfki.km.academicresearch.eswc2016challenge.cameraready.Path;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.PathList;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Map.Entry;
import java.util.Set;
import java.util.TreeMap;

public class ConfusionMatrix {
	
	private int tp,tn,fp,fn = 0;
	private Set<Path> toomuch, notfound;
		
	public void compare(PathList expected, PathList actual){
		
		tp = 0;
		tn = 0;
		fp = 0;
		fn = 0;
		
		toomuch = new HashSet();
		notfound = new HashSet();
		
		equal(expected, actual);
	}
	
	
	public void assertIt(){
		/*
		if(fp > 0){
			throw new AssertionError(String.format("Too few. We expect the pathes but they are missing: %s.", fp));
		}
		
		if(fn > 0){
			throw new AssertionError(String.format("To many. We have more in actual than in expected: %s.", fn));
		}
		*/
		
		if(fp > 0 || fn > 0){
			throw new AssertionError(String.format("Too few or too many. Too few: %s. Too Many: %s.", fp, fn));
		}
	}
	
	
	

	private void equal(PathList expected, PathList actual){
		
		TreeMap<Integer, Set<Path>> expectedMap = expected.getMap();
		TreeMap<Integer, Set<Path>> actualMap = actual.getMap();
		
		int count = 0;
		
		for(Entry<Integer, Set<Path>> entry : expectedMap.entrySet()){
			
			Set<Path> expectedPathSet = entry.getValue();
			Set<Path> actualPathSet = actualMap.getOrDefault(entry.getKey(), new HashSet());
			equals(expectedPathSet, actualPathSet, entry.getKey());
		}
			
		
		//check actualMap in expectedMap -> too many pathes
		for(Entry<Integer, Set<Path>> entry : actualMap.entrySet()){
			
			Set<Path> actualPathSet = entry.getValue();
			Set<Path> expectedPathSet = expectedMap.getOrDefault(entry.getKey(), new HashSet());
			equals(expectedPathSet, actualPathSet, entry.getKey());
		}
	}
	
	

	private void equals(Set<Path> expected, Set<Path> actual, int length){
		
		for (Path p : expected){
            if (!actual.contains(p)){
            	fp++;
            	notfound.add(p);
            	//throw new AssertionError(String.format("Too few! Following Path with length %d is expected but not in actual: %s", length, p.toString()));
            }
            else{
            	tp++;
            }
		}   	
        
        for (Path p : actual){
            if (!expected.contains(p)){
            	//throw new AssertionError(String.format("Too many! Following Path with length %d is in actual but it should not be there: %s",length, p.toString()));
            	fn++;
            	toomuch.add(p);
            }
            else{
            	tp++;
            }
		
		}
	}


	public void writeSingleFile(File file, String string) {

		String s = getRepresentation(string);
		if (s.isEmpty() == false) {
			BufferedWriter bw = null;

			try {
				// create all neccessary directories
				File f = new File(file.getAbsolutePath() + "/" + string + "/comparison.txt");
				f.getParentFile().mkdirs();

				bw = new BufferedWriter(new FileWriter(f, false));
				bw.write(getRepresentation(string));
				bw.flush();
			} catch (IOException ioe) {
				ioe.printStackTrace();
			} finally {// always close the file
				if (bw != null)
					try {
						bw.close();
					} catch (IOException ioe2) {
						// just ignore it
					}
			}
		}
	}
	
	
	public void printConsole(String string) {
		String s = getRepresentation(string);
		if(s.isEmpty() == false)
			System.out.print(s);
	}

	
	private String getRepresentation(String query){
		StringBuilder sb = new StringBuilder();
		if(notfound.size() == 0 && toomuch.size() == 0){
			return "";
		}
		
		sb.append(query);
		sb.append(System.lineSeparator());
		
		sb.append("===========not found:===========");
		sb.append(System.lineSeparator());
		for(Path p : notfound){
			sb.append(p);
			sb.append(System.lineSeparator());
		}
		sb.append(System.lineSeparator());
		sb.append(System.lineSeparator());
				
		sb.append("===========too much:===========");
		sb.append(System.lineSeparator());
		for(Path p : toomuch){
			sb.append(p);
			sb.append(System.lineSeparator());
		}
		return sb.toString();
	}
	
	
	

}
