package de.dfki.km.academicresearch.eswc2016challenge.unittests;

import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Property;
import org.apache.jena.rdf.model.Resource;
import org.apache.jena.sparql.vocabulary.FOAF;

/**
 * Vocabulary definitions from file:vocabularies/dublin-core_11.xml
 */
public class EppsteinDataset {
    /** <p>The RDF model that holds the vocabulary terms</p> */
    private static final Model m_model = ModelFactory.createDefaultModel();
    
    /** <p>The namespace of the vocabalary as a string ({@value})</p> */
    public static final String NS = "http://km.dfki.de/eswc2016challengeEppstein/";
    
    /** <p>The namespace of the vocabalary as a string</p>
     *  @see #NS */
    public static String getURI() {return NS;}
    
    /** <p>The namespace of the vocabalary as a resource</p> */
    public static final Resource NAMESPACE = m_model.createResource( NS );
    
    
    public static final Resource a = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/a");
    public static final Resource b = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/b");
    public static final Resource c = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/c");
    public static final Resource d = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/d");
    public static final Resource e = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/e");
    public static final Resource f = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/f");
    public static final Resource g = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/g");
    public static final Resource h = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/h");
    public static final Resource i = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/i");
    public static final Resource j = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/j");
    public static final Resource k = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/k");
    public static final Resource l = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/l");

    public static final Property a_b = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/a_b");
    public static final Property b_c = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/b_c");
    public static final Property c_d = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/c_d");
    public static final Property e_f = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/e_f");
    public static final Property f_g = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/f_g");
    public static final Property g_h = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/g_h");
    public static final Property i_j = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/i_j");
    public static final Property j_k = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/j_k");
    public static final Property k_l = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/k_l");      
    public static final Property a_e = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/a_e");
    public static final Property b_f = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/b_f");
    public static final Property c_g = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/c_g");
    public static final Property d_h = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/d_h");
    public static final Property e_i = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/e_i");
    public static final Property f_j = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/f_j");
    public static final Property g_k = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/g_k");
    public static final Property h_l = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/h_l");
    
    
    
    
    public static final Model getDataSet(){
    	
    	Model m = ModelFactory.createDefaultModel();
    	
    	m.add(a, a_b, b);
    	m.add(b, b_c, c);
    	m.add(c, c_d, d);
    	m.add(e, e_f, f);
    	m.add(f, f_g, g);    	
    	m.add(g, g_h, h);
    	m.add(i, i_j, j);
    	m.add(j, j_k, k);
    	m.add(k, k_l, l);
    	m.add(a, a_e, e);
    	m.add(b, b_f, f);
    	m.add(c, c_g, g);
    	m.add(d, d_h, h);
    	m.add(e, e_i, i);
    	m.add(f, f_j, j);
    	m.add(g, g_k, k);
    	m.add(h, h_l, l);
    	
    	return m;
    } 
    
    public static final Model getWeightedDataSet(){
    	
    	Model m = ModelFactory.createDefaultModel();
    	
    	m.add(a, a_b, b);
    	m.add(b, b_c, c);
    	m.add(c, c_d, d);
    	m.add(e, e_f, f);
    	m.add(f, f_g, g);    	
    	m.add(g, g_h, h);
    	m.add(i, i_j, j);
    	m.add(j, j_k, k);
    	m.add(k, k_l, l);
    	m.add(a, a_e, e);
    	m.add(b, b_f, f);
    	m.add(c, c_g, g);
    	m.add(d, d_h, h);
    	m.add(e, e_i, i);
    	m.add(f, f_j, j);
    	m.add(g, g_k, k);
    	m.add(h, h_l, l);
    	
    	m.addLiteral(a_b, PropertyPath.weight, 2);
    	m.addLiteral(b_c, PropertyPath.weight, 20);
    	m.addLiteral(c_d, PropertyPath.weight, 14);
    	m.addLiteral(e_f, PropertyPath.weight, 9);
    	m.addLiteral(f_g, PropertyPath.weight, 10);
    	m.addLiteral(g_h, PropertyPath.weight, 25);
    	m.addLiteral(i_j, PropertyPath.weight, 18);
    	m.addLiteral(j_k, PropertyPath.weight, 8);
    	m.addLiteral(k_l, PropertyPath.weight, 11);
    	m.addLiteral(a_e, PropertyPath.weight, 13);
    	m.addLiteral(b_f, PropertyPath.weight, 27);
    	m.addLiteral(c_g, PropertyPath.weight, 14);
    	m.addLiteral(d_h, PropertyPath.weight, 15);
    	m.addLiteral(e_i, PropertyPath.weight, 15);
    	m.addLiteral(f_j, PropertyPath.weight, 20);
    	m.addLiteral(g_k, PropertyPath.weight, 12);
    	m.addLiteral(h_l, PropertyPath.weight, 7);
    	
    	return m;
    } 
    
}