package de.dfki.km.academicresearch.eswc2016challenge.unittests;

import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Property;
import org.apache.jena.rdf.model.Resource;

/**
 * Vocabulary definitions from file:vocabularies/dublin-core_11.xml
 */
public class EppsteinDataset2 {
    /** <p>The RDF model that holds the vocabulary terms</p> */
    private static final Model m_model = ModelFactory.createDefaultModel();
    
    /** <p>The namespace of the vocabalary as a string ({@value})</p> */
    public static final String NS = "http://km.dfki.de/eswc2016challengeEppstein/";
    
    /** <p>The namespace of the vocabalary as a string</p>
     *  @see #NS */
    public static String getURI() {return NS;}
    
    /** <p>The namespace of the vocabalary as a resource</p> */
    public static final Resource NAMESPACE = m_model.createResource( NS );
    
    
    public static final Resource a = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/a");
    public static final Resource b = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/b");
    public static final Resource c = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/c");
    public static final Resource d = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/d");
    public static final Resource e = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/e");
    public static final Resource f = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/f");
    public static final Resource g = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/g");
    public static final Resource h = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/h");
    public static final Resource i = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/i");
    public static final Resource j = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/j");
    public static final Resource k = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/k");
    public static final Resource l = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/l");
    public static final Resource mnode = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/m");
    public static final Resource n = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/n");
    public static final Resource o = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/o");
    public static final Resource p = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/p");
    public static final Resource q = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/q");
    public static final Resource r = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/r");
    public static final Resource s = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/s");
    public static final Resource t = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/t");
    public static final Resource z = m_model.createResource("http://km.dfki.de/eswc2016challengeEppstein/z");

    public static final Property a_b = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/a_b");
    public static final Property b_c = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/b_c");
    public static final Property c_d = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/c_d");
    public static final Property e_f = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/e_f");
    public static final Property f_g = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/f_g");
    public static final Property g_h = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/g_h");
    public static final Property i_j = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/i_j");
    public static final Property j_k = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/j_k");
    public static final Property k_l = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/k_l");      
    public static final Property a_e = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/a_e");
    public static final Property b_f = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/b_f");
    public static final Property c_g = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/c_g");
    public static final Property d_h = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/d_h");
    public static final Property e_i = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/e_i");
    public static final Property f_j = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/f_j");
    public static final Property g_k = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/g_k");
    public static final Property h_l = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/h_l");
    
    public static final Property t_z = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/t_z");
    public static final Property t_b = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/t_b");
    public static final Property b_z = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/b_z");
    public static final Property c_z = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/c_z");
    public static final Property d_z = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/d_z");
    public static final Property r_t = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/r_t");
    public static final Property r_e = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/r_e");
    public static final Property r_f = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/r_f");
    public static final Property e_t = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/e_t");
    public static final Property f_t = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/f_t");
    public static final Property t_c = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/t_c");
    public static final Property t_d = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/t_d");
    public static final Property q_r = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/q_r");
    public static final Property q_i = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/q_i");
    public static final Property i_r = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/i_r");
    public static final Property p_q = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/p_q");
    public static final Property p_j = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/p_j");
    public static final Property p_k = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/p_k");
    public static final Property p_l = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/p_l");
    public static final Property p_m = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/p_m");
    public static final Property j_q = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/j_q");
    public static final Property k_q = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/k_q");
    public static final Property l_q = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/l_q");
    public static final Property m_q = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/m_q");
    public static final Property s_r = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/s_r");
    public static final Property s_g = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/s_g");
    public static final Property s_h = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/s_h");
    public static final Property g_r = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/g_r");
    public static final Property h_r = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/h_r");
    public static final Property a_p = m_model.createProperty("http://km.dfki.de/eswc2016challengeEppstein/a_p");
    
    public static final Model getWeightedDataSet(){
    	
    	Model m = ModelFactory.createDefaultModel();
    	
    	//T-Z
    	m.add(t, t_z, z); m.addLiteral(t_z, PropertyPath.weight, 5);
    	m.add(t, t_b, b); m.addLiteral(t_b, PropertyPath.weight, 3);
    	m.add(t, t_c, c); m.addLiteral(t_c, PropertyPath.weight, 7);
    	m.add(t, t_d, d); m.addLiteral(t_d, PropertyPath.weight, 9);
    	m.add(b, b_z, z); m.addLiteral(b_z, PropertyPath.weight, 6);
    	m.add(c, c_z, z); m.addLiteral(c_z, PropertyPath.weight, 6);
    	m.add(d, d_z, z); m.addLiteral(d_z, PropertyPath.weight, 6);
    	
    	
    	//R-T
    	m.add(r, r_t, t); m.addLiteral(r_t, PropertyPath.weight, 5);
    	m.add(r, r_e, e); m.addLiteral(r_e, PropertyPath.weight, 16);//17 out
    	m.add(r, r_f, f); m.addLiteral(r_f, PropertyPath.weight, 18);//19 out
    	m.add(e, e_t, t); m.addLiteral(e_t, PropertyPath.weight, 6);
    	m.add(f, f_t, t); m.addLiteral(f_t, PropertyPath.weight, 6);
    	
    	
    	//Q-R
    	m.add(q, q_r, r); m.addLiteral(q_r, PropertyPath.weight, 5);
    	m.add(q, q_i, i); m.addLiteral(q_i, PropertyPath.weight, 12);//13 out
    	m.add(i, i_r, r); m.addLiteral(i_r, PropertyPath.weight, 6);
    	
    	
    	//P-Q
    	m.add(p, p_q, q); m.addLiteral(p_q, PropertyPath.weight, 5);
    	m.add(p, p_j, j); m.addLiteral(p_j, PropertyPath.weight, 0);//1 out
    	m.add(p, p_k, k); m.addLiteral(p_k, PropertyPath.weight, 5);//6 out
    	m.add(p, p_l, l); m.addLiteral(p_l, PropertyPath.weight, 11);//12 out
    	m.add(p, p_m, mnode); m.addLiteral(p_m, PropertyPath.weight, 13);//14 out
    	m.add(j, j_q, q); m.addLiteral(j_q, PropertyPath.weight, 6);
    	m.add(k, k_q, q); m.addLiteral(k_q, PropertyPath.weight, 6);
    	m.add(l, l_q, q); m.addLiteral(l_q, PropertyPath.weight, 6);
    	m.add(mnode, m_q, q); m.addLiteral(m_q, PropertyPath.weight, 6);
    	
    	//S-R
    	m.add(s, s_r, r); m.addLiteral(s_r, PropertyPath.weight, 5);
    	m.add(s, s_g, g); m.addLiteral(s_g, PropertyPath.weight, 2);//3 out
    	m.add(s, s_h, h); m.addLiteral(s_h, PropertyPath.weight, 6);//7 out
    	m.add(g, g_r, r); m.addLiteral(g_r, PropertyPath.weight, 6);
    	m.add(h, h_r, r); m.addLiteral(h_r, PropertyPath.weight, 6);
    	
    	
    	//Start
    	m.add(a, a_p, p); m.addLiteral(a_p, PropertyPath.weight, 1);
    	
    	
    	return m;
    } 
    
}