package de.dfki.km.academicresearch.eswc2016challenge.unittests;

import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Property;
import org.apache.jena.rdf.model.Resource;

/**
 * Vocabulary definitions from file:vocabularies/dublin-core_11.xml
 */
public class ExampleDataset {
    /** <p>The RDF model that holds the vocabulary terms</p> */
    private static final Model m_model = ModelFactory.createDefaultModel();
    
    /** <p>The namespace of the vocabalary as a string ({@value})</p> */
    public static final String NS = "http://km.dfki.de/eswc2016challenge/";
    
    /** <p>The namespace of the vocabalary as a string</p>
     *  @see #NS */
    public static String getURI() {return NS;}
    
    /** <p>The namespace of the vocabalary as a resource</p> */
    public static final Resource NAMESPACE = m_model.createResource( NS );
    
    
    public static final Resource A = m_model.createResource("http://km.dfki.de/eswc2016challenge/A");
    public static final Resource B = m_model.createResource("http://km.dfki.de/eswc2016challenge/B");
    public static final Resource u1 = m_model.createResource("http://km.dfki.de/eswc2016challenge/u1");
    public static final Resource u2 = m_model.createResource("http://km.dfki.de/eswc2016challenge/u2");
    public static final Resource u3 = m_model.createResource("http://km.dfki.de/eswc2016challenge/u3");
    public static final Resource u4 = m_model.createResource("http://km.dfki.de/eswc2016challenge/u4");
    public static final Resource u5 = m_model.createResource("http://km.dfki.de/eswc2016challenge/u5");
    public static final Resource u6 = m_model.createResource("http://km.dfki.de/eswc2016challenge/u6");

    public static final Property P = m_model.createProperty("http://km.dfki.de/eswc2016challenge/P");
    public static final Property p1 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p1");
    public static final Property p2 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p2");
    public static final Property p3 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p3");
    public static final Property p4 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p4");
    public static final Property p5 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p5");
    public static final Property p6 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p6");
    public static final Property p7 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p7");
    public static final Property p8 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p8");
    
    //own
    
    public static final Resource u10 = m_model.createResource("http://km.dfki.de/eswc2016challenge/u10");
    public static final Resource u11 = m_model.createResource("http://km.dfki.de/eswc2016challenge/u11");
    public static final Resource u12 = m_model.createResource("http://km.dfki.de/eswc2016challenge/u12");
    
    public static final Property p10 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p10");
    public static final Property p11 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p11");
    public static final Property p12 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p12");
    public static final Property p13 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p13");
    public static final Property p14 = m_model.createProperty("http://km.dfki.de/eswc2016challenge/p14");
    
    /*
    static{
    	A.addProperty(p1, u1)
        .addProperty(p3, u6)
        .addProperty(P, u3);

		u1.addProperty(p2, u2);
		
		u2.addProperty(p8, B);
		
		u3.addProperty(p4, u4)
		        .addProperty(p7, B);
		
		u4.addProperty(p5, u5);
		
		u5.addProperty(p6, u3);
		
		u6.addProperty(P, B);
    	
    }*/
    
    
    public static final Model getDataSetD1(){
    	
    	Model m = ModelFactory.createDefaultModel();
    	
    	m.add(A, p1, u1);
    	m.add(A, p3, u6);
    	m.add(A, P, u3);
    	
    	m.add(u1, p2, u2);
    	
    	m.add(u2, p8, B);
    	
    	m.add(u3, p4, u4);
    	m.add(u3, p7, B);
    	
    	m.add(u4, p5, u5);
    	
    	m.add(u5, p6, u3);
    	
    	m.add(u6, P, B);
    	
    	return m;
    	//return ModelFactory.createModelForGraph(m_model.getGraph());
    }
    
    
    public static final Model getDataSetD2(){    	
    	
    	Model m = ModelFactory.createDefaultModel();
    	
    	m.add(A, p1, u1);
    	m.add(A, p3, u6);
    	m.add(A, P, u3);
    	
    	m.add(u1, p2, u2);
    	
    	m.add(u2, p8, u10);
    	
    	m.add(u3, p4, u4);
    	m.add(u3, p7, u10);
    	
    	m.add(u4, p5, u5);
    	
    	m.add(u5, p6, u3);
    	
    	m.add(u6, P, u10);
    	
    	m.add(u10, p4, B);
    	
    	return m;
    }
    
    
    public static final Model getDataSetD3(){    	
    	
    	Model m = getDataSetD1();    	
    	m.add(u3, p10, u4);    	
    	m.add(u4, p11, u5);    	
    	m.add(u5, p12, u3);
    	return m;
    }
    
    public static final Model getDataSetD4(){    	
    	
    	Model m = ModelFactory.createDefaultModel();
    	
    	m.add(A, p1, B);
    	m.add(A, p2, B);
    	
    	return m;
    }
    
    
    public static final Model getDataSetD5(){   
    	//         u2
    	//         | ^
    	//      p3 | | p4
    	//         v |
    	// A -p1->  u1  -p2-> B
    	
    	Model m = ModelFactory.createDefaultModel();
    	
    	m.add(A, p1, u1);
    	m.add(u1, p2, B);
    	m.add(u1, p4, u2);
    	m.add(u2, p3, u1);
    	return m;
    }
    
    
    public static final Model getDataSetD6(){   
    	//         u2
    	//         | ^^
    	//      p3 | || p4,5
    	//         v ||
    	// A -p1->  u1  -p2-> B
    	
    	Model m = getDataSetD5();    	
    	m.add(u1, p5, u2);
    	return m;
    }
    
    
    public static final Model getDataSetD7(){   
    	//           u2<-p6-u3
    	//         | ^      ^
    	//      p3 | | p4 p5|
    	//         v |      |
    	// A -p1->    u1     -p2-> B
    	
    	Model m = ModelFactory.createDefaultModel();    	
    	m.add(A, p1, u1);
    	m.add(u1, p2, B);
    	m.add(u1, p4, u2);
    	m.add(u2, p3, u1);
    	m.add(u1, p5, u3);
    	m.add(u3, p6, u2);
    	return m;
    }
    
    
    
    public static final Model getDataSetD8(){   
    	//           u2
    	//        | | | ^ ^ ^     
    	//  6 7 8 | | | | | |  3 4 5
    	//        v v v | | |   
    	// A -p1->    u1     -p2-> B
    	
    	Model m = ModelFactory.createDefaultModel();    	
    	m.add(A, p1, u1);
    	    	
    	m.add(u1, p3, u2);
    	m.add(u1, p4, u2);
    	m.add(u1, p5, u2);
    	
    	m.add(u2, p6, u1);
    	m.add(u2, p7, u1);
    	m.add(u2, p8, u1);
    	
    	m.add(u1, p2, B);
    	
    	return m;
    }
    
    
    public static final Model getDataSetD9(){   
    	//           u2
    	//         | | ^ ^      
    	//     5 6 | | | |   3 4 
    	//         v v | |    
    	// A -p1->    u1     -p2-> B
    	
    	Model m = ModelFactory.createDefaultModel();    	
    	m.add(A, p1, u1);
    	    	
    	m.add(u1, p3, u2);
    	m.add(u1, p4, u2);
    	
    	m.add(u2, p5, u1);
    	m.add(u2, p6, u1);
    	
    	m.add(u1, p2, B);
    	
    	return m;
    }
    
    public static final Model getDataSetLoops(int loops){   
    	//           l_i
    	//          __        
    	//         |  | .....  
    	//         v  |     
    	//          A
    	
        Model m = ModelFactory.createDefaultModel();
        for(int i = 1; i <= loops; i++) {
            Property l_i = m.createProperty("http://km.dfki.de/eswc2016challenge/l" + i);
            m.add(A, l_i, A);
        }
    	return m;
    }
    
     public static final Model getDataSetLoopsV2(int loops){   
    	//          u_2
    	//         |  |        
    	//      p2 |  | l_1 ... l_i  
    	//         v  |     
    	//  A -p1->  u1 -p3--> B
    	
        Model m = ModelFactory.createDefaultModel();
        for(int i = 1; i <= loops; i++) {
            Property l_i = m.createProperty("http://km.dfki.de/eswc2016challenge/l" + i);
            m.add(u1, l_i, u2);//sidetracks
        }
        
        m.add(A, p1, u1);
        m.add(u1, p3, B);
        
        m.add(u2, p2, u1);//spt edge
        
    	return m;
    }
    
    
}