package de.dfki.km.academicresearch.eswc2016challenge.unittests;

import de.dfki.km.academicresearch.eswc2016challenge.cameraready.PathList;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

public class WriteComparableFile {
	
	
	private static void writeFile(File dir, String expVsActual, String subdir, String query, PathList list, boolean override){

		BufferedWriter bw = null;
		 
	      try {
	    	  //create all neccessary directories
	    	  File f = new File(dir.getAbsolutePath() + "/" + subdir + "/" + expVsActual + ".txt");
	    	  boolean fileexists = f.exists();
	    	  f.getParentFile().mkdirs();
	    	  
	    	  
	         bw = new BufferedWriter(new FileWriter(f, override));
	         
	         if(fileexists == false){
	        	 bw.write(expVsActual);
			     bw.newLine();
	         }		     
		     bw.write(query);
		     bw.newLine();
		     bw.write(list.toComparableString());
		     bw.flush();
	      } catch (IOException ioe) {
	    	  ioe.printStackTrace();
	      } finally {// always close the file
		     if (bw != null) try {
		        bw.close();
		     } catch (IOException ioe2) {
		        // just ignore it
		     }
	      }
		
		
		/*
		try {
		    Files.write(Paths.get("myfile.txt"), "the text".getBytes(), StandardOpenOption.APPEND);
		}catch (IOException e) {
		    //exception handling left as an exercise for the reader
		}
		*/
		
		
	}
	
	
	/**
	 * Write a directory q1_344 and in this dir there are expected.txt and actual.txt
	 */
	public static void writeSingleFile(File dir, String query, PathList listExpected, PathList listActual){
		writeFile(dir, "expected", query, query, listExpected, false);
		writeFile(dir, "actual", query, query, listActual, false);
	}
	
	
	/**
	 * Write a directory all and in this dir there are expected.txt and actual.txt which contains all and it could be appended
	 */
	public static void writeFileToAll(File dir, String query, PathList listExpected, PathList listActual){		
		writeFile(dir, "expected", "all", query, listExpected, true);
		writeFile(dir, "actual", "all", query, listActual, true);
	}

}
