package de.dfki.km.academicresearch.eswc2016challenge.unittests.exampleTestTaskOne;

import de.dfki.km.academicresearch.eswc2016challenge.cameraready.Path;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.PathFinder;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.ExampleDataset;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.PathChooser;
import java.util.List;
import org.apache.jena.riot.system.StreamOps;
import org.apache.jena.riot.system.StreamRDF;
import org.apache.jena.riot.system.StreamRDFLib;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * This is a multigraph example
 *
 * @author Sven
 *
 */
public class ExampleTestsLoopsV2 {

    private static final Logger logger = LoggerFactory.getLogger(ExampleTestsLoopsV2.class);

    @Test
    public void testIt() throws Exception {

        for (int i = 1; i <= 10; i++) {

            PathFinder pathFinder = PathChooser.getCurrentPathFinder();
            pathFinder.setIndex("challenge_training_dataset", "datasetLoopsV2" + i);
            StreamRDF streamRDF = StreamRDFLib.sinkTriples(pathFinder);
            pathFinder.startStreaming();
            StreamOps.graphToStream(ExampleDataset.getDataSetLoopsV2(i).getGraph(), streamRDF);

            //long expectedpathes = expectedpathes(i);
            
            int expectedNumOfPaths = i + 1;
            int moreThenExist = i + 2;
            
            //we want all
            List<Path> ps = pathFinder.find(ExampleDataset.A.getURI(), ExampleDataset.B.getURI(), moreThenExist, null);
            
            //expected pathes i+1
            //A -p1-> u1 -p3-> B 
            
            //i times
            //A -p1-> u1 -li-> u2 -p2-> u1 -p3-> B
            
            for(Path p : ps) {
                logger.debug(p.toString());
            }
        }
    }
    
    
    public static long fak(long n) {
        return (n > 1 ? n * fak(n-1) : 1); 
    }
    
    public static long expectedpathes(long n) {
        //sum 4! / (4-r)!, r=1 to 4
        long sum = 0;
        for(long r = 1; r <= n; r++) {
            sum += (fak(n) / fak(n - r));
        }
        return sum;
    }

    
}
