package de.dfki.km.academicresearch.eswc2016challenge.unittests.exampleTestTaskOne;

import de.dfki.km.academicresearch.eswc2016challenge.cameraready.Path;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.PathFinder;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.PathList;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.MultigraphDataset;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.PathChooser;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.Util;
import java.util.LinkedList;
import java.util.List;
import org.apache.jena.rdf.model.Model;
import org.apache.jena.riot.system.StreamOps;
import org.apache.jena.riot.system.StreamRDF;
import org.apache.jena.riot.system.StreamRDFLib;
import org.junit.BeforeClass;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * This is a multigraph example
 *
 * @author Sven
 *
 */
public class ExampleTestsMultigraph {

    private static final Logger logger = LoggerFactory.getLogger(ExampleTests1.class);

    private static Model multigraphDataset = MultigraphDataset.getDataSet();

    //=Choose Implementation=========================================================================
    private static PathFinder pathFinder;

    @BeforeClass
    public static void onceExecutedBeforeAll() throws Exception {
        logger.debug("@BeforeClass: onceExecutedBeforeAll");

        pathFinder = PathChooser.getCurrentPathFinder();

        pathFinder.setIndex("challenge_training_dataset", "multigraph");
        if (pathFinder.hasIndex()) {
            pathFinder.loadIndex();
        } else {
            StreamRDF streamRDF = StreamRDFLib.sinkTriples(pathFinder);
            pathFinder.startStreaming();
            StreamOps.graphToStream(multigraphDataset.getGraph(), streamRDF);
        }
    }
    //========================================================================== 

    //Also multigraph!
    @Test
    public void TaskOneTestOne() throws Exception {

        List<Path> expected = new LinkedList<>();
        expected.add(new Path(MultigraphDataset.a, MultigraphDataset.a_b_1, MultigraphDataset.b, MultigraphDataset.b_c, MultigraphDataset.c));
        expected.add(new Path(MultigraphDataset.a, MultigraphDataset.a_b_2, MultigraphDataset.b, MultigraphDataset.b_c, MultigraphDataset.c));

        List<Path> actual = pathFinder.find(MultigraphDataset.a.getURI(), MultigraphDataset.c.getURI(), 2, null);

        PathList listExpected = new PathList(expected);
        PathList listActual = new PathList(actual);

        Util.equalsSlow(listExpected, listActual);
    }

}
