package de.dfki.km.academicresearch.eswc2016challenge.unittests.load;

import de.dfki.km.academicresearch.eswc2016challenge.cameraready.DataBasis;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.ModifiedEppstein;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.PathList;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.ConfusionMatrix;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.ExampleDataset;
import java.io.File;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class ModifiedEppsteinTest {
    
    private static final Logger logger = LoggerFactory.getLogger(ModifiedEppsteinTest.class);
    
    public ModifiedEppsteinTest() {
    }

    @Test
    public void eval() throws Exception {
        DataBasis data = new DataBasis("./eval");
        ModifiedEppstein modepp = new ModifiedEppstein("http://dbpedia.org/resource/Red_Bull", data);
        PathList actual = modepp.find("http://dbpedia.org/resource/Felipe_Massa", 8);
        
        //logger.debug(actual.toString());
        
        File f = new File("./challenge_training_result_sets/task1_q1_8.txt");
        PathList expected = new PathList(f);
        
        ConfusionMatrix cm = new ConfusionMatrix();
        cm.compare(expected, actual);
        cm.assertIt();
    }
    
    //@Test
    public void example() throws Exception {
        DataBasis data = new DataBasis(ExampleDataset.getDataSetD1());
        ModifiedEppstein modepp = new ModifiedEppstein(ExampleDataset.B.getURI(), data);
        modepp.find(ExampleDataset.A.getURI(), 8);
    }
    
    public void loadTrainDataset() {
        DataBasis.loadFromNTGZ("./training_dataset_filtered").save("./train");
    }
    
    public static void main(String[] args) throws Exception {
        //main for showing JTree Frame
        ModifiedEppsteinTest t = new ModifiedEppsteinTest();
        t.loadTrainDataset();
    }
    
}
