package de.dfki.km.academicresearch.eswc2016challenge.unittests.load;


import de.dfki.km.academicresearch.eswc2016challenge.cameraready.DataBasis;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.ModifiedEppsteinBidirectional;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.PathList;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.InputParam;
import de.dfki.km.academicresearch.eswc2016challenge.unittests.TaskTest.TaskTwo;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collection;
import org.junit.Assert;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@RunWith(Parameterized.class)
public class TaskTwoModEpp {

    private static final Logger logger = LoggerFactory.getLogger(TaskTwoModEpp.class);
    
    private static DataBasis data;
    
    @BeforeClass
    public static void onceExecutedBeforeAll() throws Exception {
        data = new DataBasis("./train");
    }
    //========================================================================== 

    @Parameters(name = "Test {index}:  task2_q{0}_{1}.txt")
    public static Collection<Object[]> data() {
        return Arrays.asList(new Object[][]{
            
            
            //{1, 32}, //OK 2016-04-21 
            //{1, 98}, //OK 2016-04-21
            //{1, 1914}, //OK 2016-04-21 
            //{1, 16632}, //OK 2016-04-21
            //{1, 212988}, //OK 2016-04-21
            
            //bidirctional solution!
            //{2, 3}, //OK 2016-04-21 (w/o zip)
            //{2, 4}, //OK 2016-04-21 (w/o zip)
            //{2, 76}, //OK 2016-04-21 (w/o zip)
            //{2, 151},  //zip necessary: OK 2016-04-21
            //{2, 2311}, //zip necessary: OK 2016-04-21
            
            //{3, 12},  //OK 2016-04-21
            //{3, 76}, //OK 2016-04-21
            //{3, 1440}, //OK 2016-04-21
            //{3, 8088}, //OK 2016-04-21
            
            //{4,      1}, //OK 2016-04-21
            //{4,      6}, //OK 2016-04-21
            //{4,     72}, //OK 2016-04-21
            //{4,    614}, //OK 2016-04-21 
            //{4,   5483}, //OK 2016-04-21 
            //{4,  52649}, //OK 2016-04-21
            //{4, 471199},   //OK 2016-04-21 (< 48 s) 
            
        });
    }

    private int query;
    private int k;    
    public TaskTwoModEpp(int query, int k) {
        this.query = query;
        this.k = k;
    }

    @Test
    public void test() throws FileNotFoundException, IOException, Exception {

        //expected outcome
        File f = new File("./challenge_training_result_sets/task2_q" + query + "_" + k + ".txt");
        Assert.assertTrue("File with expected results should be existing", f.exists());
        PathList expected = new PathList(f);
        
        //parameters
        InputParam params = TaskTwo.queryToParam.get(query);
        String start = params.getStart();
        String end = params.getEnd();
        String P = params.getP();

        
        String task = "task2_q" + query + "_" + k;
        logger.debug("start {}", task);
        
        //our algo
        ModifiedEppsteinBidirectional modepp = new ModifiedEppsteinBidirectional(start, end, P, k, data);
        PathList actual = modepp.find();
        
        boolean stringEqual = expected.toComparableString().equals(actual.toComparableString());
        
        //compare
        //ConfusionMatrix m = new ConfusionMatrix();
        //m.compare(expected, actual);
        //WriteComparableFile.writeFileToAll(new File("./challenge_training_dataset/"), task, expected, actual);
        //m.assertIt();
        
        Assert.assertTrue(stringEqual);
        
        logger.debug("end {}", task);
    }
    
}
