package de.dfki.km.academicresearch.eswc2016challenge.unittests.load;

import de.dfki.km.academicresearch.eswc2016challenge.cameraready.BinaryHeap;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.DataBasis;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.EdgeDelta;
import de.dfki.km.academicresearch.eswc2016challenge.cameraready.JTreeFrame;
import org.jgrapht.DirectedGraph;
import org.jgrapht.graph.DefaultDirectedGraph;

/**
 *
 * @author Markus Schr&ouml;der
 */
public class ViewerTest {
    
    public ViewerTest() {
    }

    public static void main(String[] args) throws Exception {
        graphTest();
    }
    
    private static void heapTest() throws Exception {
        DataBasis data = new DataBasis("./eval");
        
        BinaryHeap<EdgeDelta> heap = new BinaryHeap<>();
        heap.add(new EdgeDelta(0, (byte)0));
        heap.add(new EdgeDelta(1, (byte)1));
        heap.add(new EdgeDelta(2, (byte)2));
        heap.add(new EdgeDelta(3, (byte)3));
        heap.add(new EdgeDelta(4, (byte)4));
        JTreeFrame.show(heap, data);
    }
    
    private static void graphTest() throws Exception {
        DataBasis data = new DataBasis("./eval");
        
        DirectedGraph<EdgeDelta, Integer> PG = new DefaultDirectedGraph<>(Integer.class);
        int edge = 0;
        
        EdgeDelta a = new EdgeDelta(0, (byte)0);
        EdgeDelta b = new EdgeDelta(3, (byte)1);
        EdgeDelta c = new EdgeDelta(6, (byte)2);
        EdgeDelta d = new EdgeDelta(9, (byte)3);
        EdgeDelta e = new EdgeDelta(12, (byte)4);
        
        PG.addVertex(a);
        PG.addVertex(b);
        PG.addVertex(c);
        PG.addVertex(d);
        PG.addVertex(e);
        
        PG.addEdge(a, b, edge++);
        PG.addEdge(a, c, edge++);
        PG.addEdge(b, d, edge++);
        PG.addEdge(d, e, edge++);
        
        JTreeFrame.show(PG, data);
    }
}
